%tutor en espaol de kalman filter
%este tutorial pretende integrar una implementacion rapida en matlab
% con el filtro de kalman en este caso mostraremos el proceso de entonar el
% filtro a partir de una funcion escalar , pasaremos a un escalar con ruido
% y luego a una funcion con ruido el objetivo es hacer llegar un robot a
% una distancia fija de un objeto pero como hacer llegar a esta distancia
% si los sensores que tenemos presentan ruido?
%Para ello usaremos el filtro de kalman el cual nos permite eliminar rl
%ruido d e un sistema
% consideremos la distancia a un punto fijo de u nrobot que se mueve a vel
% constante la distancia al objeto varia inversamente proporcional con el tiempo
% si mi objeto esta a 300 cm el error inicial es 300-70=270
%por lo tanto la distancia es 270 +- ruido en sensores cual sera la
% distancia real dado un tiempo T ? si sabemos cual es podremos aplicar a
% nuestra ley de control y de paso eliminar valores que oscilen de una
% forma muy grande debido a ruidos externos , esto lo podemos hacer con el
% filtro de kalman

figure(4)%iniciemos un vector de L muestras
hold on;
inicial=100 %pocision de salida d enuestro robot
L = 400; %L es el numero de muestras
Z0=20; %distancia a que queremos para del objeto
D=inicial-Z0-i
%generemos un vector de ruidos que 
%simulara los valores leidos de algun sensor o muestra
n=2*randn(1,L); % la desviacion estandar del ruido es 2
z=zeros(1,L);%definimos un vector de lecturas
x=zeros(1,L);%vector d eestados nos servira despues
r=zeros(1,L);  
y=1
for (i=0:.01:10);
  
r(y)=100-100*(sin(2*i)*(exp(-i)));
y=y+1;
end;


axis([0,L,0,150]);%mantenemos los ejes de acuerdo a nuestro valor 
for (i=1:L) 
    D=inicial-Z0-i;
    z(:,i)=n(:,i)+r(:,i); %  Z0+n(:,i);  % las lacuras tienen ruido
    plot(i,z(:,i),'k'); %desplegamos las muestras 
    plot(i,r(:,i),'r'); % seal real
end;

pause  
% a partir de aqui implementaremos el filtro d ekalman   

%ahora apliquemos kalman
%X(K+1)=AXK+W
%Z(K)=HXK+V

Q=1;%covarianza del error =0;
H=1; %relacion entre variable medida y el sensxor 
A=1; %la relacion es 1 a 1
R=2;  %varianza en este caso 2

xm=0 ;%pocision inicial "estado inicial"
P=0; %el error inicial del proceso es 0
for (i=1:L) 
    
    
K=H*P*(1/(H*P*H+R));  %paso1 calculamos k
xm=xm+K*(z(:,i)-H*xm);%ajustamos la estimacion con la lectura
                   %plot(i,xm,'y+');
P=(1-K*H)*P
                   %calculamos la varianza
xm=A*xm;%proyectamos la media 
P=A*A*P+Q; %proyectamos la varianza
plot(i,xm,'b');
end ;





